package jp.rinco.android;

import java.util.Random;

import android.graphics.Canvas;

public class GameScreen {
	public static final int BASE_SIZE = 590284800;
	Random rand;
	int w, h, cw, ch;
	float xs, ys;

	public GameScreen() {
		w = BASE_SIZE;
		h = BASE_SIZE;
		rand = new Random();
	}
	public GameScreen init(Canvas c) {
		xs = cw = c.getWidth();
		ys = ch = c.getHeight();
		xs /= w;
		ys /= h;
		return this;
	}

	static GameScreen singleton;
	public static GameScreen factory() {
		return singleton == null ? (singleton = new GameScreen()) : singleton;
	}

	// ---------- Location Transform ----------
	public int w(float v) {
		return (int)(v * w);
	}
	public int h(float v) {
		return (int)(v * h);
	}
	public int scaleX(int v) {
		return (int)(v * xs);
	}
	public int scaleY(int v) {
		return (int)(v * ys);
	}
	public GameObject transform(GameObject o) {
		o.cx = scaleX(o.x);
		o.cy = scaleY(o.y);
		return o;
	}
	public GameObject setup(GameObject o) {
		o.cw = scaleX(o.w);
		o.ch = scaleY(o.h);
		return transform(o);
	}

	// -------- Location Utility ---------
	public GameObject center(GameObject o) {
		o.x = (w - o.w) / 2;
		o.y = (h - o.h) / 2;
		return o;
	}
	public GameObject random(GameObject o) {
		o.x = rand.nextInt(w - o.w);
		o.y = rand.nextInt(h - o.h);
		return o;
	}
	public GameObject warp(GameObject o) {
		o.x = warpCheck(o.x, o.w, w);
		o.y = warpCheck(o.y, o.h, h);
		return o;
	}

	static int warpCheck(int x, int w, int sw) {
		return x > sw ? -w : x < -w ? sw : x;
	}

	// -------- Other Utility ---------
	public int i(int r, int d) {
		return rand.nextInt(r) + d;
	}

}
